/* Copyright Inspirel Sp. z o.o. 2013-2015.
 * This file is part of YAMI4.
 *
 * YAMI4 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAMI4 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "log.h"

#include <stddef.h>

/* this is for demonstration only and should be changed    */
/* to the solution that is appropriate on the given target */
#include <stdio.h>

static int32_t log_activity_flags_[3] = { 0, 0, 0 };

static const char * log_module_name(const enum log_module m)
{
    const char * name;
    switch (m)
    {
    case module_main:
        name = "MAIN";
        break;
    case module_subscriptions:
        name = "SUBSCRIPTIONS";
        break;
    case module_messages:
        name = "MESSAGES";
        break;
    default:
        name = "<unknown>";
    }

    return name;
}

void log_enable(const enum log_module m, const int32_t active)
{
    log_activity_flags_[(int32_t)m] = active;
}

/* Note:                                                                          */
/* The following implementations are for demonstration only and should be changed */
/* to the solution that is appropriate on the given target.                       */

void log_put(const enum log_module m, const char msg[])
{
    if (log_activity_flags_[(int32_t)m] == 1)
    {
        printf("[%s] %s\n", log_module_name(m), msg);
    }
}

void log_put_ss(const enum log_module m, const char s1[], const char s2[])
{
    if (log_activity_flags_[(int32_t)m] == 1)
    {
        printf("[%s] %s%s\n", log_module_name(m), s1, s2);
    }
}

void log_put_sss(const enum log_module m, const char s1[], const char s2[], const char s3[])
{
    if (log_activity_flags_[(int32_t)m] == 1)
    {
        printf("[%s] %s%s%s\n", log_module_name(m), s1, s2, s3);
    }
}

void log_put_ssss(const enum log_module m, const char s1[], const char s2[],
    const char s3[], const char s4[])
{
    if (log_activity_flags_[(int32_t)m] == 1)
    {
        printf("[%s] %s%s%s%s\n", log_module_name(m), s1, s2, s3, s4);
    }
}
