/* Copyright Inspirel Sp. z o.o. 2013-2015.
 * This file is part of YAMI4.
 *
 * YAMI4 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAMI4 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef YAMI4INDUSTRY_BROKER_LOG_H
#define YAMI4INDUSTRY_BROKER_LOG_H

#include <stdint.h>

enum log_module
{
    module_main = 0,
    module_subscriptions = 1,
    module_messages = 2
};

void log_enable(enum log_module m, int32_t active);

void log_put(enum log_module m, const char msg[]);
void log_put_ss(enum log_module m, const char s1[], const char s2[]);
void log_put_sss(enum log_module m, const char s1[], const char s2[], const char s3[]);
void log_put_ssss(enum log_module m, const char s1[], const char s2[],
    const char s3[], const char s4[]);

#endif /* YAMI4INDUSTRY_BROKER_LOG_H */
