/* Copyright Inspirel Sp. z o.o. 2013-2015.
 * This file is part of YAMI4.
 *
 * YAMI4 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAMI4 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "configuration.h"
#include "log.h"
#include "messaging.h"
#include "routing.h"

int main()
{
    struct broker_properties properties;

    init_configuration(&properties);

    log_enable(module_main, properties.log_main);
    log_enable(module_subscriptions, properties.log_subscriptions);
    log_enable(module_messages, properties.log_messages);

    routing_init();

    /* Note: this is the right place to set up hard-wired subscriptions, */
    /* including forwarding entries:                                     */

    /* (void)routing_subscribe("tags", "*", "tcp://where:port");         */
    /* ...                                                               */

    /* This call never returns unless there is a serious I/O error:      */
    messaging_run(&properties);
    
    /* There was an I/O error while processing the event loop.           */
    return -1;
}
