/* Copyright Inspirel Sp. z o.o. 2013-2015.
 * This file is part of YAMI4.
 *
 * YAMI4 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAMI4 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef YAMI4INDUSTRY_LIMITS_H
#define YAMI4INDUSTRY_LIMITS_H

/* max length of network target name */
/* example: "tcp://192.168.1.10:12345"  */
#define MAX_LENGTH_OF_TARGET_NAME 32u

/* max number of channels */
#define MAX_NUMBER_OF_CHANNELS 10u

/* max size of output message payload (total buffer size)      */
/* note: the smallest possible high-level message is 132 bytes */
#define MAX_OUTGOING_MESSAGE_PAYLOAD 1024u

/* max size of input message payload (total buffer size) */
#define MAX_INCOMING_MESSAGE_PAYLOAD 1024u

/* max length of header type tag                  */
/* (normally you do not want to change this,      */
/* this is part of the high-level YAMI4 protocol) */
#define MAX_HEADER_TYPE_LENGTH 13u

/* max length of object name */
#define MAX_OBJECT_NAME_LENGTH 20u

/* max length of message name */
#define MAX_MESSAGE_NAME_LENGTH 100u

/* max length of exception (rejection) message */
#define MAX_EXCEPTION_REASON_LENGTH 200u

/* Note: the following value:
 *
 *       MAX_NUMBER_OF_CHANNELS x
 *           (MAX_OUTGOING_MESSAGE_PAYLOAD + MAX_INCOMING_MESSAGE_PAYLOAD)
 *
 * is the most significant contributor
 * to the static memory consumption of the YAMI4 agent.
 */

#endif /* YAMI4INDUSTRY_LIMITS_H */
