/* Copyright Inspirel Sp. z o.o. 2013-2015.
 * This file is part of YAMI4.
 *
 * YAMI4 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAMI4 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "options.h"

void yami_options_init(struct yami_options * const self)
{
    /* listen backlog for TCP is 10 */
    self->tcp_listen_backlog = 10;

    /* TCP listeners can reuse already bound addresses */
    self->tcp_reuseaddr = 1; /* true */

    /* TCP connections are non-blocking */
    self->tcp_nonblocking = 1; /* true */

    /* TCP connect is blocking by default (even with non-blocking setup) */
    self->tcp_connect_timeout = 0;

    /* do not use the Nagle algorithm (optimize for LANs) */
    self->tcp_nodelay = 1; /* true */

    /* do not use keepalive */
    self->tcp_keepalive = 0; /* false */
}
