/* Copyright Inspirel Sp. z o.o. 2013-2015.
 * This file is part of YAMI4.
 *
 * YAMI4 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YAMI4 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YAMI4.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef YAMI4INDUSTRY_OPTIONS_H
#define YAMI4INDUSTRY_OPTIONS_H

#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

/** Aggregate of all socket-related options.
 */
struct yami_options
{
    int32_t tcp_listen_backlog;
    int32_t tcp_reuseaddr;
    int32_t tcp_nonblocking;
    int32_t tcp_connect_timeout;
    int32_t tcp_nodelay;
    int32_t tcp_keepalive;
};

/** Initializes options to default values.
 *
 * @param self this object
 */
void yami_options_init(struct yami_options * self);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* YAMI4INDUSTRY_OPTIONS_H */
